﻿
Imports System
Imports System.IO
Imports System.Text.UTF8Encoding

Public Class Exchange_Calculator_Array
    'set up variables to store the data in. These are global variables as they may be used elsewhere
    Dim response, strexchange, strcountry, strcurrency, strsymbol As String
    Dim exchangerate, amount As Decimal
    'set up a variable to store the split csv rate in. This is a global variable as it is used elsewhere
    Dim strsplit(4), strarraysplit(4, 10) As String


    Private Sub Exchange_Calculator_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'opens the selected file
        Dim openFile As StreamReader = File.OpenText("rates.txt")
        'each line of the rates.txt file contains the following information as a csv file
        'strcountry is each country, stored as a seperate element in rates.txt
        'strcurrency is each country, stored as a seperate element in rates.txt
        'strrate is each rate, stored as a seperate element in rates.txt
        Dim C As Integer = 0
        Do While openFile.Peek <> -1

            'there are 5 students in the the file.
            strexchange = openFile.ReadLine()
            'Each element of StrSplit is gotten from whatever is read, seperated
            'by a comma 
            strsplit = strexchange.Split(",")

            ' Load split text into an array
            strarraysplit(0, C) = strsplit(0)
            strarraysplit(1, C) = strsplit(1)
            strarraysplit(2, C) = strsplit(2)
            strarraysplit(3, C) = strsplit(3)
            C = C + 1

        Loop

        'close the file
        openFile.Close()

        'load lists
        For J As Integer = 0 To C - 1
            lstCountry.Items.Add(strarraysplit(0, J))
            lstCurrency.Items.Add(strarraysplit(1, J))
            lstRate.Items.Add(strarraysplit(2, J))
            lstSymbol.Items.Add(strarraysplit(3, J))
        Next


    End Sub
    Private Sub btnconvert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnconvert.Click
        If txtCountry.Text <> "" Then  'check to see if a conversion rate has been set
            If Not IsNumeric(mtbamount.Text) Then ' check to make sure that all digits have been entered
                MsgBox("Please enter an amount for conversion", MsgBoxStyle.Critical)
                Exit Sub
            Else
                ' try / catch allows you to catch any errors without having to be specific on what type of error occurs
                'in this case we are checking to make sure the number has been entered correctly into the amount.
                Try
                    strcurrency = txtCurrency.Text
                    exchangerate = Val(txtRate.Text)
                    amount = Val(mtbamount.Text)
                    strsymbol = txtsymbol.Text
                    txtconversion.Text = strsymbol & Format((amount * exchangerate), "###0.00") & " " & strcurrency
                Catch ex As Exception
                    MsgBox("Please enter an amount for conversion", MsgBoxStyle.Critical)
                    Exit Sub
                End Try
            End If
        Else
            MsgBox("Please choose a currency to convert to", MsgBoxStyle.Critical)
            Exit Sub
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Startup.Show()
        Me.Close()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        About.Show()
        Me.Hide()
    End Sub

    Private Sub CountryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CountryToolStripMenuItem.Click
        'hide conversion details
        HideConversion()

        'show Edit Button
        btnedit.Show()

        MsgBox("Please choose the relevant country from the list below, make your changes and then click on the Edit button", MsgBoxStyle.OkOnly)
    End Sub

    Private Sub AddNewCountryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddNewCountryToolStripMenuItem.Click
        'hide conversion details
        HideConversion()

        MsgBox("Please enter new data into the relevant boxes and then click on the Add button", MsgBoxStyle.OkOnly)


    End Sub
    Private Sub btnadd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnAdd.Click
        ' check to make sure the data is enetered correctly before saving
        If txtCountry.Text = "" Or txtCurrency.Text = "" Or txtRate.Text = "" Or txtsymbol.Text = "" Then
            MsgBox("Please enter the correct data into the relevant text boxes", MsgBoxStyle.Critical)
            Exit Sub
        ElseIf Not IsNumeric(txtRate.Text) Then
            MsgBox("Please enter a number into the rate text box", MsgBoxStyle.Critical)
            Exit Sub
        Else

            'Load new item into array and list
            Dim J As Integer = lstCountry.Items.Count ' Get size of current array and list

            'add new items into array
            strarraysplit(0, J) = txtCountry.Text
            strarraysplit(1, J) = txtCurrency.Text
            strarraysplit(2, J) = txtRate.Text
            strarraysplit(3, J) = txtsymbol.Text
            'add new items to lists
            lstCountry.Items.Item(J) = txtCountry.Text
            lstCurrency.Items.Item(J) = txtCurrency.Text
            lstRate.Items.Item(J) = txtRate.Text
            lstSymbol.Items.Item(J) = txtsymbol.Text
        End If

        'write the new output to rates.txt
        writetext()

        'show conversion details
        ShowConversion()

    End Sub

    Private Sub DeleteCountryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteCountryToolStripMenuItem.Click
        'hide conversion details
        HideConversion()

        'show Delete Button
        btndelete.Show()

        MsgBox("Please choose the country you wish to delete from the list below and then click on the Delete button", MsgBoxStyle.OkOnly)


    End Sub

    Private Sub btndelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btndelete.Click
        Dim I As Integer = lstCountry.SelectedIndices.Item(0)

        If lstCountry.SelectedItems.Count = 1 Then
            
            response = MsgBox("Do you really want to delete " & txtCountry.Text & " from your list", MsgBoxStyle.YesNo)

            If response = DialogResult.Yes Then
                'remove item from lists and arrays
                lstCountry.Items.RemoveAt(I)
                lstCurrency.Items.RemoveAt(I)
                lstRate.Items.RemoveAt(I)
                lstSymbol.Items.RemoveAt(I)
                strarraysplit(0, I).Remove(I)

                'write the new output to rates.txt
                writetext()

            Else
                'show conversion details
                ShowConversion()
                Exit Sub
            End If
        End If
    End Sub

    Private Sub btnedit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnedit.Click
        Dim J As Integer = lstCountry.SelectedIndex
        response = MsgBox("Do you really want to edit " & lstCountry.Items.Item(J) & " in your list", MsgBoxStyle.YesNo)

        If response = DialogResult.Yes Then
            'add new items into array
            strarraysplit(0, J) = txtCountry.Text
            strarraysplit(1, J) = txtCurrency.Text
            strarraysplit(2, J) = txtRate.Text
            strarraysplit(3, J) = txtsymbol.Text
            'add new items to lists
            lstCountry.Items.Item(J) = txtCountry.Text
            lstCurrency.Items.Item(J) = txtCurrency.Text
            lstRate.Items.Item(J) = txtRate.Text
            lstSymbol.Items.Item(J) = txtsymbol.Text

            'write the new output to rates.txt
            writetext()

        Else
            'show conversion details
            ShowConversion()
            Exit Sub
        End If
    End Sub
    Private Sub writetext()
        Dim FileNum As Integer = FreeFile()
        FileOpen(FileNum, "rates.txt", OpenMode.Output)
        For I = 0 To lstCountry.Items.Count - 1
            PrintLine(FileNum, lstCountry.Items.Item(I) & "," & lstCurrency.Items.Item(I) & "," & lstRate.Items.Item(I) & "," & lstSymbol.Items.Item(I))
        Next I
        FileClose(FileNum)
    End Sub
    Private Sub ShowConversion()
        'show conversion details
        txtconversion.Show()
        mtbamount.Show()
        lblconversion.Show()
        lblamount.Show()
        lbldollar.Show()
        btnconvert.Show()

        'show currency details
        lblcountry.Hide()
        txtCountry.Hide()
        txtCountry.Clear()
        lblcurrency.Hide()
        txtCurrency.Hide()
        txtCurrency.Clear()
        lblrate.Hide()
        txtRate.Hide()
        txtRate.Clear()
        lblsymbol.Hide()
        txtsymbol.Hide()
        txtsymbol.Clear()
        btnAdd.Hide()
        btnedit.Hide()
        btndelete.Hide()
    End Sub
    Private Sub HideConversion()
        'hide conversion details
        txtconversion.Hide()
        mtbamount.Hide()
        lblconversion.Hide()
        lblamount.Hide()
        lbldollar.Hide()
        btnconvert.Hide()
        btnAdd.Hide()
        btnedit.Hide()

        'show currency details
        lblcountry.Show()
        txtCountry.Show()
        txtCountry.Clear()
        lblcurrency.Show()
        txtCurrency.Show()
        txtCurrency.Clear()
        lblrate.Show()
        txtRate.Show()
        txtRate.Clear()
        lblsymbol.Show()
        txtsymbol.Show()
        txtsymbol.Clear()

    End Sub

    Private Sub lstCountry_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lstCountry.Click
        Dim Lindex As Integer
        Lindex = lstCountry.SelectedIndex
        txtCountry.Text = lstCountry.SelectedItem
        txtCurrency.Text = lstCurrency.Items.Item(Lindex)
        txtRate.Text = lstRate.Items.Item(Lindex)
        txtsymbol.Text = lstSymbol.Items.Item(Lindex)
    End Sub
    Private Sub Newlists(ByVal Country As String, ByVal Currency As String, ByVal Rate As Decimal, ByVal symbol As String, ByVal Row As Integer)

        'load 
        lstCountry.Items.Item(Row) = Country
        lstCurrency.Items.Item(Row) = Currency
        lstRate.Items.Item(Row) = Rate
        lstSymbol.Items.Item(Row) = symbol

    End Sub
End Class

