﻿Imports System
Imports System.IO
Imports System.Text.UTF8Encoding

Public Class Exchange_Calculator_Listview
    'set up variables to store the data in. These are global variables as they may be used elsewhere
    Dim response, strexchange, strcountry, strcurrency, strsymbol As String
    Dim exchangerate, amount As Decimal
    'set up a variable to store the split csv rate in. This is a global variable as it is used elsewhere
    Dim strsplit(4), strarraysplit(4, 10) As String


    Private Sub Exchange_Calculator_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        'opens the selected file
        Dim openFile As StreamReader = File.OpenText("rates.txt")
        'each line of the rates.txt file contains the following information as a csv file
        'strcountry is each country, stored as a seperate element in rates.txt
        'strcurrency is each country, stored as a seperate element in rates.txt
        'strrate is each rate, stored as a seperate element in rates.txt

        'Input data until End of file is seen
        Do While openFile.Peek <> -1

            'there are 5 students in the the file.
            strexchange = openFile.ReadLine()
            'Each element of StrSplit is gotten from whatever is read, seperated
            'by a comma 
            strsplit = strexchange.Split(",")

            'Filling out the Listview
            NewListview(strsplit(0), strsplit(1), strsplit(2), strsplit(3))
            'Dim lvw As New ListViewItem
            'lvw.Text = strsplit(0)          'Add the country to the first column
            'lvw.SubItems.Add(strsplit(1))   'Add the currencyy to the second column
            'lvw.SubItems.Add(strsplit(2))   'Add the currencyy to the second column
            'lvw.SubItems.Add(strsplit(3))   'Add the rate to the third column
            'lvwExchangeRate.Items.Add(lvw)  'Add the new listview item to the listview grid

        Loop

        'close the file
        openFile.Close()

    End Sub

    Private Sub lvwExchangeRate_SelectedIndexChanged(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles lvwExchangeRate.SelectedIndexChanged
        If lvwExchangeRate.SelectedItems.Count = 1 Then
            'this sets up the listview as the item to be used for data input into the text boxes
            With lvwExchangeRate.SelectedItems(0)       '// with Selected item.
                txtCountry.Text = .Text                 '// item text.                
                txtCurrency.Text = .SubItems(1).Text    '// item column 2.Text 
                txtRate.Text = .SubItems(2).Text        '// item column 3.Text
                txtsymbol.Text = .SubItems(3).Text      '// item column 4.Text
            End With
        End If

    End Sub

    Private Sub btnconvert_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnconvert.Click
        If txtCountry.Text <> "" Then  'check to see if a conversion rate has been set
            If Not IsNumeric(mtbamount.Text) Then ' check to make sure that all digits have been entered
                MsgBox("Please enter an amount for conversion", MsgBoxStyle.Critical)
                Exit Sub
            Else
                ' try / catch allows you to catch any errors without having to be specific on what type of error occurs
                'in this case we are checking to make sure the number has been entered correctly into the amount.
                Try
                    strcurrency = txtCurrency.Text
                    exchangerate = Val(txtRate.Text)
                    amount = Val(mtbamount.Text)
                    strsymbol = txtsymbol.text
                    txtconversion.Text = strsymbol & Format((amount * exchangerate), "###0.00") & " " & strcurrency
                Catch ex As Exception
                    MsgBox("Please enter an amount for conversion", MsgBoxStyle.Critical)
                    Exit Sub
                End Try
            End If
        Else
            MsgBox("Please choose a currency to convert to", MsgBoxStyle.Critical)
            Exit Sub
        End If
    End Sub

    Private Sub ExitToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles ExitToolStripMenuItem.Click
        Startup.Show()
        Me.Close()
    End Sub

    Private Sub AboutToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AboutToolStripMenuItem.Click
        About.Show()
        Me.Hide()
    End Sub

    Private Sub CountryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CountryToolStripMenuItem.Click
        'hide conversion details
        HideConversion()
        ''hide conversion details
        'txtconversion.Hide()
        'mtbamount.Hide()
        'lblconversion.Hide()
        'lblamount.Hide()
        'lbldollar.Hide()
        'btnconvert.Hide()
        'btnAdd.Hide()
        'btnedit.Hide()

        ''show currency details
        'lblcountry.Show()
        'txtCountry.Show()
        'txtCountry.Clear()
        'lblcurrency.Show()
        'txtCurrency.Show()
        'txtCurrency.Clear()
        'lblrate.Show()
        'txtRate.Show()
        'txtRate.Clear()
        'lblsymbol.Show()
        'txtsymbol.Show()
        'txtsymbol.Clear()

        'show Edit Button
        btnedit.Show()

        MsgBox("Please choose the relevant country from the list below, make your changes and then click on the Edit button", MsgBoxStyle.OkOnly)
    End Sub

    Private Sub AddNewCountryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles AddNewCountryToolStripMenuItem.Click
        'hide conversion details
        HideConversion()
        ''hide conversion details
        'txtconversion.Hide()
        'mtbamount.Hide()
        'lblconversion.Hide()
        'lblamount.Hide()
        'lbldollar.Hide()
        'btnconvert.Hide()
        'btnAdd.Hide()
        'btnedit.Hide()

        ''show currency details
        'lblcountry.Show()
        'txtCountry.Show()
        'txtCountry.Clear()
        'lblcurrency.Show()
        'txtCurrency.Show()
        'txtCurrency.Clear()
        'lblrate.Show()
        'txtRate.Show()
        'txtRate.Clear()
        'lblsymbol.Show()
        'txtsymbol.Show()
        'txtsymbol.Clear()

        'Show Add Button
        btnAdd.Show()

        MsgBox("Please enter new data into the relevant boxes and then click on the Add button", MsgBoxStyle.OkOnly)


    End Sub
    Private Sub btnadd_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles btnadd.Click
        ' check to make sure the data is enetered correctly before saving
        If txtCountry.Text = "" Or txtCurrency.Text = "" Or txtRate.Text = "" Or txtsymbol.Text = "" Then
            MsgBox("Please enter the correct data into the relevant text boxes", MsgBoxStyle.Critical)
            Exit Sub
        ElseIf Not IsNumeric(txtRate.Text) Then
            MsgBox("Please enter a number into the rate text box", MsgBoxStyle.Critical)
            Exit Sub
        Else
            'Load_ListviewItem
            NewListview(txtCountry.Text, txtCurrency.Text, txtRate.Text, txtsymbol.Text)

        End If

        'write the new output to rates.txt
        writetext()


        'Dim FileNum As Integer = FreeFile()
        'FileOpen(FileNum, "rates.txt", OpenMode.Output)
        'For I = 0 To lvwExchangeRate.Items.Count - 1
        '    Dim lvw As New ListViewItem()
        '    lvw = lvwExchangeRate.Items.Item(I)
        '    PrintLine(FileNum, lvw.Text & "," & lvw.SubItems(1).Text & "," & lvw.SubItems(2).Text & "," & lvw.SubItems(3).Text)
        'Next I
        'FileClose(FileNum)



    End Sub

    Private Sub DeleteCountryToolStripMenuItem_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles DeleteCountryToolStripMenuItem.Click
        'hide conversion details
        HideConversion()

        ''hide conversion details
        'txtconversion.Hide()
        'mtbamount.Hide()
        'lblconversion.Hide()
        'lblamount.Hide()
        'lbldollar.Hide()
        'btnconvert.Hide()
        'btnAdd.Hide()
        'btnedit.Hide()

        ''show currency details
        'lblcountry.Show()
        'txtCountry.Show()
        'txtCountry.Clear()
        'lblcurrency.Show()
        'txtCurrency.Show()
        'txtCurrency.Clear()
        'lblrate.Show()
        'txtRate.Show()
        'txtRate.Clear()
        'lblsymbol.Show()
        'txtsymbol.Show()
        'txtsymbol.Clear()

        'show Delete Button
        btndelete.Show()

        MsgBox("Please choose the country you wish to delete from the list below and then click on the Delete button", MsgBoxStyle.OkOnly)


    End Sub

    Private Sub btndelete_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btndelete.Click
        Dim I As Integer = lvwExchangeRate.SelectedIndices.Item(0)

        If lvwExchangeRate.SelectedItems.Count = 1 Then
            With lvwExchangeRate.SelectedItems(0)       '// with Selected item.
                txtCountry.Text = .Text                 '// item text.                
                txtCurrency.Text = .SubItems(1).Text    '// item column 2.Text 
                txtRate.Text = .SubItems(2).Text        '// item column 3.Text
                txtsymbol.Text = .SubItems(3).Text      '// item column 3.Text
            End With
            response = MsgBox("Do you really want to delete " & txtCountry.Text & " from your list", MsgBoxStyle.YesNo)

            If response = DialogResult.Yes Then
                'remove item from listview
                lvwExchangeRate.Items.RemoveAt(I)

                'write the new output to rates.txt
                writetext()


                'Dim FileNum As Integer = FreeFile()
                'FileOpen(FileNum, "rates.txt", OpenMode.Output)
                'For I = 0 To lvwExchangeRate.Items.Count - 1
                '    Dim lvw As New ListViewItem()
                '    lvw = lvwExchangeRate.Items.Item(I)
                '    PrintLine(FileNum, lvw.Text & "," & lvw.SubItems(1).Text & "," & lvw.SubItems(2).Text & "," & lvw.SubItems(3).Text)
                'Next I
                'FileClose(FileNum)


            Else
                'show conversion details
                ShowConversion()

                ''show conversion details
                'txtconversion.Show()
                'mtbamount.Show()
                'lblconversion.Show()
                'lblamount.Show()
                'lbldollar.Show()
                'btnconvert.Show()

                ''show currency details
                'lblcountry.Hide()
                'txtCountry.Hide()
                'txtCountry.Clear()
                'lblcurrency.Hide()
                'txtCurrency.Hide()
                'txtCurrency.Clear()
                'lblrate.Hide()
                'txtRate.Hide()
                'txtRate.Clear()
                'lblsymbol.Hide()
                'txtsymbol.Hide()
                'txtsymbol.Clear()
                'btnAdd.Hide()
                'btnedit.Hide()
                'btndelete.Hide()

                Exit Sub
            End If
        End If
    End Sub

    Private Sub btnedit_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles btnedit.Click
        Dim I As Integer = lvwExchangeRate.SelectedIndices.Item(0)

        response = MsgBox("Do you really want to edit " & txtCountry.Text & " in your list", MsgBoxStyle.YesNo)

        If response = DialogResult.Yes Then
            Me.lvwExchangeRate.Items(I).Text = txtCountry.Text
            Me.lvwExchangeRate.Items(I).SubItems(1).Text = txtCurrency.Text
            Me.lvwExchangeRate.Items(I).SubItems(2).Text = txtRate.Text
            Me.lvwExchangeRate.Items(I).SubItems(3).Text = txtsymbol.Text

            'write the new output to rates.txt
            writetext()


            'Dim FileNum As Integer = FreeFile()
            'FileOpen(FileNum, "rates.txt", OpenMode.Output)
            'For I = 0 To lvwExchangeRate.Items.Count - 1
            '    Dim lvw As New ListViewItem()
            '    lvw = lvwExchangeRate.Items.Item(I)
            '    PrintLine(FileNum, lvw.Text & "," & lvw.SubItems(1).Text & "," & lvw.SubItems(2).Text & "," & lvw.SubItems(3).Text)
            'Next I
            'FileClose(FileNum)


        Else
            'show conversion details
            ShowConversion()

            ''show conversion details
            'txtconversion.Show()
            'mtbamount.Show()
            'lblconversion.Show()
            'lblamount.Show()
            'lbldollar.Show()
            'btnconvert.Show()

            ''show currency details
            'lblcountry.Hide()
            'txtCountry.Hide()
            'txtCountry.Clear()
            'lblcurrency.Hide()
            'txtCurrency.Hide()
            'txtCurrency.Clear()
            'lblrate.Hide()
            'txtRate.Hide()
            'txtRate.Clear()
            'lblsymbol.Hide()
            'txtsymbol.Hide()
            'txtsymbol.Clear()
            'btnAdd.Hide()
            'btnedit.Hide()
            'btndelete.Hide()


            Exit Sub
        End If
    End Sub
    Private Sub writetext()
        Dim FileNum As Integer = FreeFile()
        FileOpen(FileNum, "rates.txt", OpenMode.Output)
        For I = 0 To lvwExchangeRate.Items.Count - 1
            Dim lvw As New ListViewItem()
            lvw = lvwExchangeRate.Items.Item(I)
            PrintLine(FileNum, lvw.Text & "," & lvw.SubItems(1).Text & "," & lvw.SubItems(2).Text & "," & lvw.SubItems(3).Text)
        Next I
        FileClose(FileNum)

        'show conversion details
        ShowConversion()

        ''show conversion details
        'txtconversion.Show()
        'mtbamount.Show()
        'lblconversion.Show()
        'lblamount.Show()
        'lbldollar.Show()
        'btnconvert.Show()

        ''show currency details
        'lblcountry.Hide()
        'txtCountry.Hide()
        'txtCountry.Clear()
        'lblcurrency.Hide()
        'txtCurrency.Hide()
        'txtCurrency.Clear()
        'lblrate.Hide()
        'txtRate.Hide()
        'txtRate.Clear()
        'lblsymbol.Hide()
        'txtsymbol.Hide()
        'txtsymbol.Clear()
        'btnAdd.Hide()
        'btnedit.Hide()
        'btndelete.Hide()

    End Sub
    Private Sub ShowConversion()
        'show conversion details
        txtconversion.Show()
        mtbamount.Show()
        lblconversion.Show()
        lblamount.Show()
        lbldollar.Show()
        btnconvert.Show()

        'show currency details
        lblcountry.Hide()
        txtCountry.Hide()
        txtCountry.Clear()
        lblcurrency.Hide()
        txtCurrency.Hide()
        txtCurrency.Clear()
        lblrate.Hide()
        txtRate.Hide()
        txtRate.Clear()
        lblsymbol.Hide()
        txtsymbol.Hide()
        txtsymbol.Clear()
        btnAdd.Hide()
        btnedit.Hide()
        btndelete.Hide()
    End Sub
    Private Sub HideConversion()
        'hide conversion details
        txtconversion.Hide()
        mtbamount.Hide()
        lblconversion.Hide()
        lblamount.Hide()
        lbldollar.Hide()
        btnconvert.Hide()
        btnAdd.Hide()
        btnedit.Hide()

        'show currency details
        lblcountry.Show()
        txtCountry.Show()
        txtCountry.Clear()
        lblcurrency.Show()
        txtCurrency.Show()
        txtCurrency.Clear()
        lblrate.Show()
        txtRate.Show()
        txtRate.Clear()
        lblsymbol.Show()
        txtsymbol.Show()
        txtsymbol.Clear()

    End Sub
    Private Sub NewListview(ByVal Country As String, ByVal Currency As String, ByVal Rate As Decimal, ByVal Symbol As String)
        'Load_ListviewItem
        Dim lvw As New ListViewItem
        lvw.Text = Country          'Add the country to the first column
        lvw.SubItems.Add(Currency)  'Add the currencyy to the second column
        lvw.SubItems.Add(Rate)      'Add the currencyy to the second column
        lvw.SubItems.Add(Symbol)    'Add the rate to the third column
        lvwExchangeRate.Items.Add(lvw)
    End Sub
End Class
